;-------------------------------------------------------------
;       Routines d'affichage pour afficheur LCD 2*16 car     -
;-------------------------------------------------------------
                                                                

; les 7 donnees sont sur le port A.
; la sortie E est sur la sortie B0
; la sortie RS est sur la sortie B1 port B, bit 1
; port A et B doivent etre configuree en sortie Push-Pull
; configure en write-only
; Quartz de 3.2768 => Tcycle=3.66us 

;-------------------------------------------------------------
;               Envoie une commande                          -
;-------------------------------------------------------------

; la commande a envoyee se trouve ds le registre A
LCDWcmd         ldi drb,0           ;RS=0, E=0
                ld  dra,a           ;commande=>bus LCD
                ldi drb,1           ;E=>1
                nop                 ;Attente 40us
                nop
                nop
                ldi drb,0
                ret

;-------------------------------------------------------------
;               Envoie une donnee                            -
;-------------------------------------------------------------
;la donnee a envoyer est contenu ds a
LCDWdata        ldi drb,2           ;RS=1, E=0
                ld  dra,a           ;commande=>bus LCD
                ldi drb,3           ;E=>1
                nop                 ;40 us
                nop
                nop
                ldi drb,2
                ret         
;-------------------------------------------------------------
;               Ecrit un chiffre                             -
;-------------------------------------------------------------
;la donnee a envoyer est contenu ds a    
LCDWnum         addi a,30h
                call LCDWdata
                ret
;-------------------------------------------------------------
;               Attente                                      -
;-------------------------------------------------------------
; attend 40 us environ : 1 nop=4 cycles          
LCDWait         ldi wdr,0feh
                nop
                nop
                ret
                 
;-------------------------------------------------------------
;-                          initialisation                   -
;-------------------------------------------------------------
LCDInit         ldi x,2              ;attend 15ms environ
LCD2            ldi a,255            
LCD1            call LCDWait
                dec a
                jrnz LCD1
                ld a,x
                dec a
                ld x,a
                jrnz LCD2 
                
                ldi a,16+32         ;envoi du premier code
                call LCDWcmd
                
                ldi a,103           ;attend 4.1 ms environ
LCD3            call LCDWait
                dec a
                jrnz LCD3
                
                ldi a,16+32         ;envoi 2eme code
                call LCDWcmd
                
                call LCDWait        ;attend environ 100us
                call LCDWait
                call LCDWait

                ldi a,16+32         ;envoi du 3eme code
                call LCDWcmd
                
                ldi a,103
LCD4            call LCDWait
                dec a
                jrnz LCD4

                ldi a,8+16+32       ;4 eme code
                call LCDWcmd
                call LCDWait
                
                ldi a,8
                call LCDWcmd
                call LCDWait
                
                ldi a,1
                call LCDWcmd
                call LCDWait
                
                ldi a,41            ;1.6ms
LCD9            call LCDWait
                dec a
                jrnz LCD9
                            
                ldi a,4+2
                call LCDWcmd
                call LCDWait
        
                ldi a,8+4
                call LCDWcmd
                call LCDWait
                
                ldi a,16+8+4
                call LCDWcmd        ;cursor on, display on                
                ret                 ;fin de la routine d'initialisation
                
            
;-------------------------------------------------------------
;        Envoie une chainde de caractere pointee par X       -
;-------------------------------------------------------------   
; registre modifie : A
; delimiteur de fin de chaine : 0 (utilisation de .ASCIIZ)

LCDWstrg        nop
LCD5            ld a,(x)
                jrz LCD6
                call LCDWdata
                call LCDWait
                inc x
                jp LCD5 
LCD6            ret

 
;-------------------------------------------------------------
;        Positionne le curseur                               -
;-------------------------------------------------------------
;X contient la colone et A la ligne (A=1 ou A=2)
; A est modifie
LCDPos          cpi a,1
                jrnz LCD7
                ld a,x            
                set 7,a            ;ligne 1      
                call LCDWcmd
                jp LCD8
LCD7            ld a,x              ;ligne 2
                set 7,a             ;
                set 6,a
                call LCDWcmd
LCD8            call LCDWait
                ret
;-------------------------------------------------------------
;         Clear the display                                  -
;-------------------------------------------------------------
LCDClear        ldi a,1
                call LCDWcmd
                ldi a,41            ;1.6ms
LCD10           call LCDWait
                dec a
                jrnz LCD10
                ret
